#include <iostream>
#include <vector>

typedef long long ll;

using namespace std;

vector <int> vec[300001];
int used[300001], dp[300001][2];
vector <int> p, cycle, obn;

void dfs(int v, int pred)
{
    used[v] = 1;
    obn.push_back(v);
    p.push_back(v);
    for (int i = 0; i < vec[v].size(); i++)
    {
        if (cycle.size() != 0)
            return;
        int u = vec[v][i];
        if (used[u] == 1 && u != pred)
        {
            cycle.push_back(u);
            int q = p.size() - 1;
            while (p[q] != u)
            {
                cycle.push_back(p[q]);
                q--;
            }
            return;
        }
        if (used[u] == 0)
            dfs(u, v);
    }
    p.pop_back();
    return;
}

void dp_c(int v)
{
    used[v] = 1;
    int sum = 0, sum1 = 1;
    for (int i = 0; i < vec[v].size(); i++)
    {
        int u = vec[v][i];
        if (used[u] == 0)
        {
            dp_c(u);
            sum += max(dp[u][1], dp[u][0]);
            sum1 += dp[u][0];
        }
    }
    dp[v][0] = sum;
    dp[v][1] = sum1;
    return;
}

int ans_cycle(vector <int> c)
{
    if (c.size() > 3)
    {
        int dp_cycle[c.size() - 3][2];
        for (int i = 0; i < c.size() - 3; i++)
        {
            if (i == 0)
            {
                dp_cycle[i][0] = dp[c[i + 2]][0];
                dp_cycle[i][1] = dp[c[i + 2]][1];
            } else {
                dp_cycle[i][0] = max(dp_cycle[i - 1][0], dp_cycle[i - 1][1]) + dp[c[i + 2]][0];
                dp_cycle[i][1] = dp[c[i + 2]][1] + dp_cycle[i - 1][0];
            }
        }
        int ans = max(dp_cycle[c.size() - 4][0], dp_cycle[c.size() - 4][1]);
        int dp_cycle1[c.size() - 1][2];
        for (int i = 0; i < c.size() - 1; i++)
        {
            if (i == 0)
            {
                dp_cycle[i][0] = dp[c[i + 1]][0];
                dp_cycle[i][1] = dp[c[i + 1]][1];
            } else {
                dp_cycle[i][0] = max(dp_cycle[i - 1][0], dp_cycle[i - 1][1]) + dp[c[i + 1]][0];
                dp_cycle[i][1] = dp[c[i + 1]][1] + dp_cycle[i - 1][0];
            }
        }
        ans = max(ans, max(dp_cycle[c.size() - 2][0], dp_cycle[c.size() - 2][1]));
        return ans;
    }
    return max(dp[c[0]][1] + dp[c[1]][0] + dp[c[2]][0], max(dp[c[0]][0] + dp[c[1]][1] + dp[c[2]][0], dp[c[0]][0] + dp[c[1]][0] + dp[c[2]][1]));
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);

    int n;
    cin >> n;
    int x, ans = 0;
    for (int i = 0; i < n; i++)
    {
        cin >> x;
        if (x != -1)
        {
            vec[x].push_back(i + 1);
            vec[i + 1].push_back(x);
        }
    }
    for (int i = 1; i <= n; i++)
    {
        if (used[i] == 0)
        {
            dfs(i, -1);
            for (int j = 0; j < obn.size(); j++)
                used[obn[j]] = 0;
            if (cycle.size() != 0)
            {
                for (int j = 0; j < cycle.size(); j++)
                    used[cycle[j]] = 1;
                for (int j = 0; j < cycle.size(); j++)
                    dp_c(cycle[j]);
                ans += ans_cycle(cycle);
                cycle.clear();
            } else {
                dp_c(i);
                ans += max(dp[i][0], dp[i][1]);
            }
            p.clear();
            obn.clear();
        }
    }
    cout << ans;
    return 0;
}
